import es
import popuplib
import playerlib
import gamethread

info = es.AddonInfo()
info.name = 'SurfTools'
info.version = '0.9' 
info.url = 'http://addons.eventscripts.com/addons/view/surftools'
info.basename =  'surftools'
info.author = 'Dav1d / *zensiert*'

### Noblock settings
noblock = 1 # 1 for all maps, 0 all maps in noblock_maps
noblock_maps = [] # what maps? For example ['surf_fruits', 'surf_Animals']
noblock_active = True # Do not change this!
noblock = bool(noblock) # Do not change this!
## !block settings, just works when noblock is 1
block = 1 # 1 = True, 0 = False, 1 allows a user to use !block to get in blocking mode
block_time = 15 # How long does he "block"
block = bool(block) # Do not change this

### Respawn settings
respawn = 1 # 1 for all maps, 0 all maps in respawn_maps
respawn_maps = [] # what maps? For example ['surf_fruits', 'surf_Animals']
respawn_time = 3
respawn_active = True # Do not change this!
respawn = bool(respawn) # Do not change this!

# Spawnprotection settings
spawnprotect = 1 # 1 for all maps, 0 all maps in spawnprotect_maps
spawnprotect_maps = [] # what maps? For example ['surf_fruits', 'surf_Animals']
spawnprotect_time = 8
spawnprotect_active = True # Do not change this!
spawnprotect = bool(spawnprotect) # Do not change this!

################## don't edit something below here!
def unload():
    popuplib.delete('intropop')

def round_end(event_var):
    gamethread.cancelDelayed('end_spawnprotect')
    gamethread.cancelDelayed('respawn')
    gamethread.cancelDelayed('noblock_again')

def es_map_start(event_var):
    global noblock_active
    global respawn_active
    global spawnprotect_active
    cur_map = event_var['mapname']
    # Noblock
    if not noblock:
        if cur_map in noblock_maps:
            noblock_active = True
        else:
            noblock_active = False
    else:
        noblock_active = True
    # Respawn
    if not respawn:
        if cur_map in respawn_maps:
            respawn_active = True
        else:
            respawn_active = False
    else:
        respawn_active = True
    # Spawnprotection
    if not spawnprotect:
        if cur_map in spawnprotect_maps:
            spawnprotect_active = True
        else:
            spawnprotect_active = False
    else:
        spawnprotect_active = True
    
    intropop = popuplib.create('intropop')
    intropop.addline('Written by Dav1d aka *zensiert*')
    intropop.addline('-------------------------------------')
    intropop.addline('------------[SurfTools]------------')
    intropop.addline('-------------------------------------')
    intropop.addline('')
    if noblock_active:
        intropop.addline('Noblock is currently activated, write !block to get "blocking"')
    if spawnprotect_active:
        intropop.addline('SpawnProtection is currently activated')
    if respawn_active:
        intropop.addline('Respawn is currently activated to respawn write !re or !respawn')


def round_start(event_var):
    es.msg('#multi', '#green [SurfTools]#lightgreen is running on this server, written by Dav1d aka *zensiert*')

def player_activate(event_var):
    userid = event_var['userid']
    popuplib.send('intropop', userid)

def player_spawn(event_var):
    userid = event_var['userid']
    team = es.getplayerteam(userid)
    if noblock_active:
        es.setplayerprop(userid, 'CBaseEntity.m_CollisionGroup', 2)
    if spawnprotect_active:
        if team == 2:
            playerlib.getPlayer(userid).set('color', (255, 0, 0, 255))
        elif team == 3:
            playerlib.getPlayer(userid).set('color', (0, 0, 255, 255))
        else:
            playerlib.getPlayer(userid).set('color', (255, 255, 255, 255))
        es.setplayerprop(userid, 'CBasePlayer.m_lifeState', 0) 
        es.tell(userid, '#multi','#green [SurfTools]#lightgreen You are now protected for %s seconds' % spawnprotect_time)
        gamethread.delayedname(spawnprotect_time, 'end_spawnprotect', end_spawnprotect, userid) 
    

def end_spawnprotect(userid):    
    playerlib.getPlayer(userid).set('color', (255, 255, 255, 255))
    es.setplayerprop(userid, 'CBasePlayer.m_lifeState', 512) 
    es.tell(userid, '#multi','#green [SurfTools]#lightgreen You are no longer protected')
        
def player_death(event_var):
    userid = event_var['userid']
    es.setplayerprop(userid, 'CBaseEntity.m_CollisionGroup', 2)
    if respawn_active:
        es.tell(userid, '#multi', '#green [SurfTools]#lightgreen You will respawn in %s seconds' % (respawn_time))
        gamethread.delayedname(respawn_time, 'respawn', respawn, userid)

def player_say(event_var):
    userid = event_var['userid']
    text = event_var['text']
    # Respawn
    if text in ('!re', '!respawn'):
        if playerlib.getPlayer(userid).getAttribute('isdead'):
            es.tell(userid, '#multi', '#green [SurfTools]#lightgreen You will respawn in %s seconds' % (respawn_time))
            gamethread.delayedname(respawn_time, 'respawn', respawn, userid)
    # !block
    elif text == '!block':
        if not playerlib.getPlayer(userid).getAttribute('isdead'):
            if noblock_active and block:
                es.tell(userid, '#multi', '#green [SurfTools]#lightgreen You are now blocking for %s seconds'
                                                                                            % (block_time))
                es.setplayerprop(userid, 'CBaseEntity.m_CollisionGroup', 5)
                gamethread.delayedname(block_time, 'noblock_again', noblock_again, userid)

def noblock_again(userid):
    es.setplayerprop(userid, 'CBaseEntity.m_CollisionGroup', 2)
    es.tell(userid, '#multi', '#green [SurfTools]#lightgreen You are no longer blocking')

def player_team(event_var):
    player_say(event_var)

def respawn(userid):
    es.server.queuecmd('est_spawn %s 0' % (userid))
